# Source code for azure.mgmt.applicationinsights.operations.favorites_operations

    # coding=utf-8
    # --------------------------------------------------------------------------
    # Copyright (c) Microsoft Corporation. All rights reserved.
    # Licensed under the MIT License. See License.txt in the project root for
    # license information.
    #
    # Code generated by Microsoft (R) AutoRest Code Generator.
    # Changes may cause incorrect behavior and will be lost if the code is
    # regenerated.
    # --------------------------------------------------------------------------

    import uuid
    from msrest.pipeline import ClientRawResponse
    from msrestazure.azure_exceptions import CloudError

    from .. import models

    class FavoritesOperations(object):
        """FavoritesOperations operations.

        :param client: Client for service requests.
        :param config: Configuration of service client.
        :param serializer: An object model serializer.
        :param deserializer: An object model deserializer.
        :ivar api_version: The API version to use for this operation. Constant value: "2015-05-01".
        """

        models = models

        def __init__(self, client, config, serializer, deserializer):

            self._client = client
            self._serialize = serializer
            self._deserialize = deserializer
            self.api_version = "2015-05-01"

            self.config = config

        def list(
                self, resource_group_name, resource_name, favorite_type="shared", source_type=None, can_fetch_content=None, tags=None, custom_headers=None, raw=False, **operation_config):
            """Gets a list of favorites defined within an Application Insights
            component.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param resource_name: The name of the Application Insights component
             resource.
            :type resource_name: str
            :param favorite_type: The type of favorite. Value can be either shared
             or user. Possible values include: 'shared', 'user'
            :type favorite_type: str or
             ~azure.mgmt.applicationinsights.models.FavoriteType
            :param source_type: Source type of favorite to return. When left out,
             the source type defaults to 'other' (not present in this enum).
             Possible values include: 'retention', 'notebook', 'sessions',
             'events', 'userflows', 'funnel', 'impact', 'segmentation'
            :type source_type: str or
             ~azure.mgmt.applicationinsights.models.FavoriteSourceType
            :param can_fetch_content: Flag indicating whether or not to return the
             full content for each applicable favorite. If false, only return
             summary content for favorites.
            :type can_fetch_content: bool
            :param tags: Tags that must be present on each favorite returned.
            :type tags: list[str]
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: list or ClientRawResponse if raw=true
            :rtype:
             list[~azure.mgmt.applicationinsights.models.ApplicationInsightsComponentFavorite]
             or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.list.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceName': self._serialize.url("resource_name", resource_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)
            if favorite_type is not None:
                query_parameters['favoriteType'] = self._serialize.query("favorite_type", favorite_type, 'FavoriteType')
            if source_type is not None:
                query_parameters['sourceType'] = self._serialize.query("source_type", source_type, 'str')
            if can_fetch_content is not None:
                query_parameters['canFetchContent'] = self._serialize.query("can_fetch_content", can_fetch_content, 'bool')
            if tags is not None:
                query_parameters['tags'] = self._serialize.query("tags", tags, '[str]', div=',')

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.get(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None

            if response.status_code == 200:
                deserialized = self._deserialize('[ApplicationInsightsComponentFavorite]', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        list.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Insights/components/{resourceName}/favorites'}

        def get(
                self, resource_group_name, resource_name, favorite_id, custom_headers=None, raw=False, **operation_config):
            """Get a single favorite by its FavoriteId, defined within an Application
            Insights component.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param resource_name: The name of the Application Insights component
             resource.
            :type resource_name: str
            :param favorite_id: The Id of a specific favorite defined in the
             Application Insights component
            :type favorite_id: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ApplicationInsightsComponentFavorite or ClientRawResponse if
             raw=true
            :rtype:
             ~azure.mgmt.applicationinsights.models.ApplicationInsightsComponentFavorite
             or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.get.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceName': self._serialize.url("resource_name", resource_name, 'str'),
                'favoriteId': self._serialize.url("favorite_id", favorite_id, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.get(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None

            if response.status_code == 200:
                deserialized = self._deserialize('ApplicationInsightsComponentFavorite', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        get.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Insights/components/{resourceName}/favorites/{favoriteId}'}

        def add(
                self, resource_group_name, resource_name, favorite_id, favorite_properties, custom_headers=None, raw=False, **operation_config):
            """Adds a new favorites to an Application Insights component.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param resource_name: The name of the Application Insights component
             resource.
            :type resource_name: str
            :param favorite_id: The Id of a specific favorite defined in the
             Application Insights component
            :type favorite_id: str
            :param favorite_properties: Properties that need to be specified to
             create a new favorite and add it to an Application Insights component.
            :type favorite_properties:
             ~azure.mgmt.applicationinsights.models.ApplicationInsightsComponentFavorite
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ApplicationInsightsComponentFavorite or ClientRawResponse if
             raw=true
            :rtype:
             ~azure.mgmt.applicationinsights.models.ApplicationInsightsComponentFavorite
             or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.add.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceName': self._serialize.url("resource_name", resource_name, 'str'),
                'favoriteId': self._serialize.url("favorite_id", favorite_id, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(favorite_properties, 'ApplicationInsightsComponentFavorite')

            # Construct and send request
            request = self._client.put(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None

            if response.status_code == 200:
                deserialized = self._deserialize('ApplicationInsightsComponentFavorite', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        add.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Insights/components/{resourceName}/favorites/{favoriteId}'}

        def update(
                self, resource_group_name, resource_name, favorite_id, favorite_properties, custom_headers=None, raw=False, **operation_config):
            """Updates a favorite that has already been added to an Application
            Insights component.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param resource_name: The name of the Application Insights component
             resource.
            :type resource_name: str
            :param favorite_id: The Id of a specific favorite defined in the
             Application Insights component
            :type favorite_id: str
            :param favorite_properties: Properties that need to be specified to
             update the existing favorite.
            :type favorite_properties:
             ~azure.mgmt.applicationinsights.models.ApplicationInsightsComponentFavorite
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ApplicationInsightsComponentFavorite or ClientRawResponse if
             raw=true
            :rtype:
             ~azure.mgmt.applicationinsights.models.ApplicationInsightsComponentFavorite
             or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.update.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceName': self._serialize.url("resource_name", resource_name, 'str'),
                'favoriteId': self._serialize.url("favorite_id", favorite_id, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(favorite_properties, 'ApplicationInsightsComponentFavorite')

            # Construct and send request
            request = self._client.patch(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None

            if response.status_code == 200:
                deserialized = self._deserialize('ApplicationInsightsComponentFavorite', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        update.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Insights/components/{resourceName}/favorites/{favoriteId}'}

        def delete(
                self, resource_group_name, resource_name, favorite_id, custom_headers=None, raw=False, **operation_config):
            """Remove a favorite that is associated to an Application Insights
            component.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param resource_name: The name of the Application Insights component
             resource.
            :type resource_name: str
            :param favorite_id: The Id of a specific favorite defined in the
             Application Insights component
            :type favorite_id: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: None or ClientRawResponse if raw=true
            :rtype: None or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.delete.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceName': self._serialize.url("resource_name", resource_name, 'str'),
                'favoriteId': self._serialize.url("favorite_id", favorite_id, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.delete(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                return client_raw_response
        delete.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Insights/components/{resourceName}/favorites/{favoriteId}'}